/**************************************************************************
EASY MSc Dissertation - Project
Ken Webb
August 4, 2004
Rndm.h: interface for the Rndm class.

These are static functions that can be used by instances of any class to
get random numbers.
**************************************************************************/

#if !defined(AFX_RNDM_H__E718553A_6CE4_43EA_8B05_83BDC17CB808__INCLUDED_)
#define AFX_RNDM_H__E718553A_6CE4_43EA_8B05_83BDC17CB808__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Rndm  
{
public:
	Rndm();
	virtual ~Rndm();

	// Seed the random number generator
	static void seedRandomNumberGenerator( void );

	// Get a random real (double) between 0.0 and 1.0
	static double getRandomReal01( void ); // Get a random number >= 0.0 and < 1.0
	// Get a random integer between 0 and maxVal inclusive
	static int getRandomInt( int maxVal );
	// Get a random integer between minVal and maxVal inclusive
	static int getRandomInt( int minVal, int maxVal );
	// Run a test
	static void testRandom( int minVal, int maxVal, int numIter );
};

#endif // !defined(AFX_RNDM_H__E718553A_6CE4_43EA_8B05_83BDC17CB808__INCLUDED_)
